package net.lecnam.info;

import java.util.concurrent.BlockingQueue;
import java.util.logging.Level;
import java.util.logging.Logger;

public class Client implements Runnable {

	BlockingQueue<Integer> in;
	BlockingQueue<Integer> out;

	Client(BlockingQueue<Integer> in, BlockingQueue<Integer> out) {
		this.in = in;
		this.out = out;
	}

	public int size() {
		try {
			out.put(-2);
			int s = in.take();
			return s;
		} catch (InterruptedException ex) {
			throw new Error(ex);
		}
	}

	public Integer get(int index) {
		try {
			out.put(index);
			int elt = in.take();
			return elt;
		} catch (InterruptedException ex) {
			throw new Error(ex);
		}
	}

	public void stop() {
		try {
			out.put(-1);
		} catch (InterruptedException ex) {
			throw new Error(ex);
		}
	}

	@Override
	public void run() {
		int s = size();
		System.out.println("size: " + s);
		for (int i = 0; i < s; i++) {
			int elt = get(i);
			System.out.println(elt);
		}
		stop();
	}

}
